<script>
    import { createEventDispatcher } from 'svelte'
    import { validateSelf } from 'lib/validate'

    export let name
    export let type
    export let value
    export let rules

    const dispatch = createEventDispatcher()

    export const validate = async () => {
        const errors = await validateSelf(rules, value)
        dispatch('errors', errors)
        return errors.length === 0
    }

    const typeAction = element => (element.type = type)
</script>

<input id={name} on:input {name} use:typeAction bind:value />

<style lang="postcss">
    input {
        @apply w-full text-teal-600;

        &:focus {
            @apply outline-none;
        }
    }
</style>
